#!/system/bin/sh

alias bb=/res/bin/busybox
action="/res/synapse/actions";

SELF_FILENAME=$0
SELF_PID=$$
SLEEP_DELAY=4
LCD_IS=2
AOD_MODE=0
AOD_SHOW=0
AOD_RUNTIME=0
CURRENT_FOCUS_OLD=""
INTELLI_PERF_FLAG=1
INTELLI_PERF_FLAG_OLD=0
SQLITE="/res/bin/sqlite3";
CFG_SYNAPSE=/res/synapse/settings
DB_SYNAPSE="/data/data/com.af.synapse/databases/actionValueStore";
SETTINGS_SYS_FILE="/data/system/users/0/settings_system.xml"
#aod_auto_bright=$(cat /res/synapse/settings/aod_autobrightness)
intelli_perf_enable=$(cat /res/synapse/settings/intelli_perf_enable)
LOADER_VER=$(cat /data/PRIME-Kernel/synapse_loader_ver)

DONT_KILL_THIS()
{
	PIDOF=$$
	for i in $PIDOF; do
		echo "-950" > /proc/${i}/oom_score_adj
	done
}

KILL_THIS_NOW()
{
	PIDOF=$$
	for i in $PIDOF; do
		kill $i
	done
}

SET_VAR()
{
	TMP=$(cat $1)
	if [ ! -f $1 ]; then
		exit 0
	fi
	if [ "$2" != "$TMP" ]; then
		echo "$2" > $1
		log -p i -t "BG-TUNE" "set '$1' as $2";
	fi
}

GAMETUNE()
{
	intelli_perf_enable=$(cat /res/synapse/settings/intelli_perf_enable)

	if [ $LCD_IS -eq 0 ] || [ $intelli_perf_enable -eq 0 ]; then
		return 0
	fi

	TMP=$(dumpsys window windows | bb grep "mFocusedApp=")
	TMP=${TMP%/*}
	CURRENT_FOCUS=${TMP##* }

	if [ "$CURRENT_FOCUS" != "$CURRENT_FOCUS_OLD" ]
	then
		local _DATA="/data/data/com.enhance.gameservice/databases"
		local _DB="/data/data/com.enhance.gameservice/databases/database"
		local _WHITELIST="/sdcard/Synapse/pakage_intelli_perf_whitelist.txt"

		log -p i -t "BG-TUNE" "Focus Changed"

		ret=`$SQLITE $_DB "SELECT category_code, custom_dss, custom_dfs, brightness FROM package WHERE package_name='$CURRENT_FOCUS';"`

		if [ "$ret" ]
		then
			IFS='|'
			data=($ret)
			category=${data[0]}

			log -p i -t "BG-TUNE" "Detected Gametuner Registered"

			if [ "$category" == "game" ]; then
				INTELLI_PERF_FLAG=1
				if [ "$LOADER_VER" != "" ]; then
					dss=${data[1]%.*}
					dfs=${data[2]%.*}
					brightness=${data[3]}
					local ENABLE_FOR_RES=$(cat /res/synapse/settings/intelli_resolution)
					local ENABLE_FOR_RES_VAL=$(cat /res/synapse/settings/intelli_resolution_val)
					local DISABLE_FOR_FPS=$(cat /res/synapse/settings/intelli_fps)
					local DISABLE_FOR_FPS_VAL=$(cat /res/synapse/settings/intelli_fps_val)
					local DISABLE_FOR_BRIGHTNESS=$(cat /res/synapse/settings/intelli_brightness)

					log -p i -t "BG-TUNE" "is Game"

					if [ $DISABLE_FOR_FPS -eq 1 ] && [ $DISABLE_FOR_FPS_VAL -ge $dfs ]; then
						INTELLI_PERF_FLAG=0
					fi
					if [ $ENABLE_FOR_RES -eq 1 ] && [ $ENABLE_FOR_RES_VAL -ge $dss ]; then
						INTELLI_PERF_FLAG=0
					fi
					if [ $DISABLE_FOR_BRIGHTNESS -eq 1 ] && [ "$brightness" != "-1" ]; then
						INTELLI_PERF_FLAG=0
					fi
				fi
			else
				INTELLI_PERF_FLAG=0
			fi
		else
			INTELLI_PERF_FLAG=0
		fi

		# if charge...?
		if [ $INTELLI_PERF_FLAG -eq 1 ] && [ $(cat /res/synapse/settings/intelli_perf_if_charge) -eq 1 ]; then
			power_status=$(cat /sys/devices/battery/power_supply/battery/status)
			if [ $power_status == "Discharging" ]; then
				INTELLI_PERF_FLAG=0
			fi
		fi

		if [ $INTELLI_PERF_FLAG -eq 1 ] || [ $INTELLI_PERF_FLAG_OLD -eq 1 ]
		then
			local intelli_perf_kfc_max=$(cat /res/synapse/settings/intelli_cpu0_max)
			local intelli_perf_cpu_max=$(cat /res/synapse/settings/intelli_cpu4_max)
			local CPUCORE_NOLIMIT=$(cat $CFG_SYNAPSE/cpucore_max_no_limit)
			local PERF_BOOST=$(cat /res/synapse/settings/intelli_perf_boost)
			local CPU0_GOV=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor)
			local CPU4_GOV=$(cat /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor)
			local HOTPLUG_DRIVER=$(cat /res/synapse/settings/hotplug_prof)
		fi

		log -p i -t "BG-TUNE" INTELLI_PERF_FLAG: $INTELLI_PERF_FLAG
		log -p i -t "BG-TUNE" INTELLI_PERF_OLD : $INTELLI_PERF_FLAG_OLD
		log -p i -t "BG-TUNE" CPUCORE_NOLIMIT: $CPUCORE_NOLIMIT

		if [ $INTELLI_PERF_FLAG -eq 1 ]; then
			SET_VAR /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq $(($intelli_perf_kfc_max))
			SET_VAR /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq $(($intelli_perf_cpu_max))

			if [ "$LOADER_VER" != "" ] && [ $PERF_BOOST -eq 1 ]; then
				SET_VAR /sys/kernel/hmp/boost 1
				#SET_VAR /sys/devices/14ac0000.mali/dvfs_governor 3
				#SET_VAR /sys/devices/system/cpu/cpu0/cpufreq/$CPU0_GOV/boost 1
				#SET_VAR /sys/devices/system/cpu/cpu4/cpufreq/$CPU4_GOV/boost 1
				SET_VAR /proc/sys/kernel/sched_cfs_boost 99
				if [ "$HOTPLUG_DRIVER" == "Stock" ]; then
					SET_VAR /sys/power/cpuhotplug/enabled 0
				elif [ "$HOTPLUG_DRIVER" == "ThunerPlug" ]; then
					SET_VAR /sys/module/state_notifier/parameters/enabled N
					SET_VAR /sys/kernel/thunderplug/hotplug_enabled 0
				fi
			fi
			log -p i -t "BG-TUNE" "Intelli-Perfomance Running..."
		elif [ $INTELLI_PERF_FLAG_OLD -eq 1 ]; then
			local FREQ_KFC=$(cat $CFG_SYNAPSE/cpu0_max_freq)
			local FREQ_CPU=$(cat $CFG_SYNAPSE/cpu4_max_freq)
			#local GPU_GOVERNOR=$($SQLITE $DB_SYNAPSE "SELECT value FROM action_value WHERE key = 'gpu_governor gpu_gov';")
			local CPU0_GOV_BOOST=$($SQLITE $DB_SYNAPSE "SELECT value FROM action_value WHERE key = 'generic /sys/devices/system/cpu/cpu0/cpufreq/$CPU0_GOV/boost';")
			local CPU4_GOV_BOOST=$($SQLITE $DB_SYNAPSE "SELECT value FROM action_value WHERE key = 'generic /sys/devices/system/cpu/cpu4/cpufreq/$CPU4_GOV/boost';")
			local EAS_SCHED_BOOST=$($SQLITE $DB_SYNAPSE "SELECT value FROM action_value WHERE key = 'generic /proc/sys/kernel/sched_cfs_boost';")

			SET_VAR /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq $FREQ_KFC
			SET_VAR /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq $FREQ_CPU

			if [ "$LOADER_VER" != "" ] && [ $PERF_BOOST -eq 1 ]; then
				SET_VAR /sys/kernel/hmp/boost 0
				#SET_VAR /sys/devices/14ac0000.mali/dvfs_governor $GPU_GOVERNOR
				#SET_VAR /sys/devices/system/cpu/cpu0/cpufreq/$CPU0_GOV/boost $CPU0_GOV_BOOST
				#SET_VAR /sys/devices/system/cpu/cpu4/cpufreq/$CPU4_GOV/boost $CPU0_GOV_BOOST
				SET_VAR /proc/sys/kernel/sched_cfs_boost $EAS_SCHED_BOOST
				if [ "$HOTPLUG_DRIVER" == "Stock" ]; then
					SET_VAR /sys/power/cpuhotplug/enabled 1
					SET_VAR /sys/module/state_notifier/parameters/enabled N
				elif [ "$HOTPLUG_DRIVER" == "ThunerPlug" ]; then
					SET_VAR /sys/module/state_notifier/parameters/enabled Y
					SET_VAR /sys/kernel/thunderplug/hotplug_enabled 1
				fi
			fi
			log -p i -t "BG-TUNE" "Intelli-Perfomance Exit..."
		fi
	fi

	CURRENT_FOCUS_OLD="$CURRENT_FOCUS"
	INTELLI_PERF_FLAG_OLD=$INTELLI_PERF_FLAG
	intelli_perf_enable_old=$intelli_perf_enable
}

SET_BRIGHTNESS()
{
	local i=$1
	local max=$2
	local delay=$3

	AOD_CHECK

	if [ $i -eq $max ] || [ $AOD_SHOW -eq 0 ]; then
		return 0
	fi

	if [ $i -le $max ]; then
		while [[ $i -le $max ]] && [ $AOD_SHOW -eq 1 ]
		do
		  echo $i > /sys/class/backlight/panel/brightness
		  i=$(($i+1))
		  bb usleep $delay
		  AOD_CHECK
		done
	else
		while [[ i -ge $max ]] && [ $AOD_SHOW -eq 1 ]
		do
		  echo $i > /sys/class/backlight/panel/brightness
		  i=$(($i-1))
		  bb usleep $delay
		  AOD_CHECK
		done
	fi
}

SCREEN_ON()
{
	log -p i -t "BG-TUNE" "Screen is off";
}

SCREEN_OFF()
{
#	str_temp=$(cat $SETTINGS_SYS_FILE|grep 'name="aod_show_state"')
#	AOD_SHOW=$(bb expr match "$str_temp" '.*value="\(.\)"')
	CALL_STAT=$(CALL_CHECK)

	if [ ! $CALL_STAT -eq 0 ]; then
		SCREEN_ON
		return 0
	fi

	local IDLE_MODE=$(dumpsys deviceidle step)
	local FORCED_DOZE=$(cat /res/synapse/settings/aod_forced_doze)
	local CHARGE_TYPE=$(cat /sys/devices/battery*/power_supply/battery/charge_type)
	local IDLE_MODE=""
	local IDLE_MODE_OLD=""

	if [ $FORCED_DOZE -eq 1 ] && [ "$CHARGE_TYPE" == "Battery" ]; then
		dumpsys deviceidle force-idle
		while [ "$IDLE_MODE" != "Stepped to: ACTIVE" ] || [ "$IDLE_MODE" != "Stepped to: IDLE" ]
		do
			IDLE_MODE=$(dumpsys deviceidle step)
			if [ "$IDLE_MODE" == "$IDLE_MODE_OLD" ]; then
				break
			else
				sleep 1
			fi
		done
		log -p i -t "BG-TUNE" "$IDLE_MODE";
	fi
}

AOD_CHECK()
{
	str_temp=$(cat $SETTINGS_SYS_FILE|grep 'name="aod_mode"')
	AOD_MODE=$(bb expr match "$str_temp" '.*value="\(.\)"')
	#AOD_MODE=$(settings get system aod_mode) #very slow
	str_temp=$(cat $SETTINGS_SYS_FILE|grep 'name="aod_show_state"')
	AOD_SHOW=$(bb expr match "$str_temp" '.*value="\(.\)"')
	#AOD_SHOW=$(settings get system aod_show_state) #very slow
	aod_auto_bright=$(cat /res/synapse/settings/aod_autobrightness)
}

CALL_CHECK()
{
	str_temp=$(dumpsys telephony.registry | bb grep 'mCallState')
	echo ${str_temp#*=}
}

# ===============================
#       Support AOD Service
# ===============================
AOD_SVC()
{
	local PROXIMITY=""
	local LUX_W=""
	local BCALC=""
	local CURRTIME=""
	local CURRENT=""

	aod_abl_term=$(cat /res/synapse/settings/aod_autobrightness_term)
	aod_auto_bright=$(cat /res/synapse/settings/aod_autobrightness)
	CURRTIME=$(bb date +%s)

	if [ $AOD_RUNTIME -eq 0 ]; then
		AOD_RUNTIME=$(($CURRTIME + 5))
	fi
	if [ $aod_auto_bright -eq 1 ] && [ $(bb expr $CURRTIME \> $AOD_RUNTIME ) -eq 1 ]
	then
		if [ $AOD_SHOW -eq 1 ]
		then
			PROXIMITY=$(cat /sys/class/sensors/proximity_sensor/state)

			if [ ! $LCD_IS -eq 0 ]; then
				SCREEN_OFF
			fi

			if [ $PROXIMITY -lt 255 ]; then
				LUX_W=$(cat /sys/class/sensors/light_sensor/lux | cut -d"," -f4)
				BCALC=$(echo "$LUX_W 1500" | bb awk '{printf "%.0f", $1/$2*100}' | bb awk '{printf "%.0f",$1/0.255}')
				# Limit to the maximum value of the display.
				if [ $BCALC -gt 255 ]; then
					BCALC=255
				fi
			else
				BCALC=0
			fi

			CURRENT=$(cat /sys/class/backlight/panel/brightness)
			CALL_STAT=$(CALL_CHECK)
			if [ $CALL_STAT -eq 0 ] && [ ! $CURRENT -eq $BCALC ]; then
				SET_BRIGHTNESS $CURRENT $BCALC 8000 &
				log -p i -t "BG-TUNE" "SET_BRIGHTNESS to $BCALC";
			fi
		fi
		AOD_RUNTIME=$(($CURRTIME + $aod_abl_term))
	elif [ $(bb expr $CURRTIME \> $AOD_RUNTIME) -eq 1 ]; then
		aod_auto_bright=$(cat /res/synapse/settings/aod_autobrightness)
		AOD_RUNTIME=$(($CURRTIME + 5))
	fi

	LCD_IS=0
}

(
while :
do
	BG_SERVICE_ACTIVE=$(cat /res/synapse/settings/enable_bgtune)

#	if [ $aod_auto_bright -eq 1 ] && [ $AOD_SHOW -eq 1 ]; then
#		SLEEP_DELAY=2
	if [ $BG_SERVICE_ACTIVE -eq 1 ]; then
		SLEEP_DELAY=4
	else
		KILL_THIS_NOW
	fi
	sleep $SLEEP_DELAY

#	AOD_CHECK

#	if [ $AOD_SHOW -eq 0 ];	then
		BRIGHTNESS=$(cat /sys/class/backlight/panel/brightness)

		if [ $BRIGHTNESS -eq 0 ]; then
			[ ! $LCD_IS -eq 0 ] && SCREEN_OFF
			LCD_IS=0
		else
			[ $LCD_IS -eq 0 ] && SCREEN_ON
			LCD_IS=1
		fi
#	else
#		AOD_SVC
#	fi

	if [ $LCD_IS -eq 1 ]; then
		GAMETUNE
	fi
done
) &

DONT_KILL_THIS
